using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class SuperpowerSyringe : SyringeBehaviour
{
    public override string GetLiquidID() => SuperpowerSerum.ID;

	public class SuperpowerSerum : Liquid
	{
		public const string ID = "SUPERPOWER SERUM";

		public SuperpowerSerum()
		{
			Color = new UnityEngine.Color(1f, 1f, 1f);
		}

		public override void OnEnterLimb(LimbBehaviour limb)
		{
			limb.gameObject.GetOrAddComponent<SuperpowerBehaviour>();
		}

		public override void OnUpdate(BloodContainer container) { }
		public override void OnEnterContainer(BloodContainer container) { }
		public override void OnExitContainer(BloodContainer container) { }
	}
}

public class SuperpowerBehaviour : MonoBehaviour
{
    public void Start()
    {
		LimbBehaviour limb = this.gameObject.GetComponent<LimbBehaviour>();
        limb.BaseStrength = 20f;
        limb.RegenerationSpeed = 1f;
        limb.ShotDamageMultiplier = 0f;
        limb.BreakingThreshold = float.PositiveInfinity;
        limb.InitialHealth = 20;
        limb.Health = limb.InitialHealth;

        StartCoroutine(MakeStrong());
    }

    public void OnCollisionEnter2D(Collision2D other)
    {
		LimbBehaviour limb = this.gameObject.GetComponent<LimbBehaviour>();
        if (limb.Person.IsAlive())
			other.gameObject.GetComponent<Rigidbody2D>().velocity = this.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.velocity * 6f;
    }

    private IEnumerator MakeStrong()
    {
		LimbBehaviour limb = this.gameObject.GetComponent<LimbBehaviour>();
        limb.CirculationBehaviour.HealBleeding();
        limb.Numbness = 0f;
        limb.Person.Consciousness = 1f;

        yield return new WaitForEndOfFrame();
        StartCoroutine(MakeStrong());
    }
}