using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;

public class TrapSyringe : SyringeBehaviour
{
    public override string GetLiquidID() => TrapSerum.ID;

	public class TrapSerum : Liquid
	{
		public const string ID = "TRAP SERUM";

		public TrapSerum()
		{
			Color = new UnityEngine.Color(1f, 0.6f, 0.3f);
		}

		public override void OnEnterLimb(LimbBehaviour limb)
		{
			limb.gameObject.GetOrAddComponent<TrapBehaviour>().Start();
		}

		public override void OnUpdate(BloodContainer container) { }
		public override void OnEnterContainer(BloodContainer container) { }
		public override void OnExitContainer(BloodContainer container) { }
	}
}

public class TrapBehaviour : MonoBehaviour
{
	public void Start()
	{
		StartCoroutine("Initiate");
	}

    private IEnumerator Initiate()
    {
		LimbBehaviour limb = this.gameObject.GetComponent<LimbBehaviour>();
        if (!limb.Person.IsAlive())
        {
            StartCoroutine("Explode");
            yield break;
        }
        yield return new WaitForSeconds(1f);
        StartCoroutine("Initiate");
    }

    private IEnumerator Explode()
    {
		LimbBehaviour limb = this.gameObject.GetComponent<LimbBehaviour>();
        if (!limb.Person.IsAlive())
        {
            yield return new WaitForSeconds(2f);
            ExplosionCreator.CreatePulseExplosion(limb.transform.position, 0.75f, 10f, true, true);
			limb.Crush();
        }
    }
}